summaryrefslogtreecommitdiffstats
path: root/target
diff options
context:
space:
mode:
authornbd <nbd@3c298f89-4303-0410-b956-a3cf2f4a3e73>2005-03-23 13:31:22 +0000
committernbd <nbd@3c298f89-4303-0410-b956-a3cf2f4a3e73>2005-03-23 13:31:22 +0000
commit5bd92e199ff0fdd9a2efec325dd9c79e0600f238 (patch)
tree5e1d4dd8e92ccd8380f4e4fb1fe2ca2f57b710d5 /target
parent1e0e58da9a0794dfe0e4b0e787f2ae82aa2b44d3 (diff)
add mount_root script to mount root fs (called from /etc/preinit)
git-svn-id: svn://svn.openwrt.org/openwrt/trunk/openwrt@428 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'target')
-rwxr-xr-xtarget/default/target_skeleton/etc/preinit24
-rwxr-xr-xtarget/default/target_skeleton/sbin/mount_root24
2 files changed, 26 insertions, 22 deletions
diff --git a/target/default/target_skeleton/etc/preinit b/target/default/target_skeleton/etc/preinit
index c6ad0d706..9a80a7e07 100755
--- a/target/default/target_skeleton/etc/preinit
+++ b/target/default/target_skeleton/etc/preinit
@@ -6,27 +6,7 @@ sleep 1
if [ $(cat /proc/sys/reset) = 1 ] ; then
export FAILSAFE=true
while :; do { echo $(((X=(X+1)%8)%2)) > /proc/sys/diag; sleep $((X==0)); } done &
-else
- mount | grep jffs2 >&-
- if [ $? = 0 ] ; then
- mtd unlock rootfs
- [ $(cat /proc/mtd | wc -l) = 6 ] && {
- echo 5 > /proc/sys/diag
- mtd unlock OpenWrt
- mtd erase OpenWrt
- jffs2root --move
- }
- mount -o remount,rw /dev/root /
- else
- mtd unlock mtd4
- mount -t jffs2 /dev/mtdblock/4 /jffs
- pivot_root /jffs /jffs/rom
- mount none /dev -t devfs
- mount none /proc -t proc
- umount rom/proc rom/dev
- fi
fi
-mount none /tmp -t ramfs
-mkdir -p /dev/pts
-mount none /dev/pts -t devpts
+/sbin/mount_root ${FAILSAFE:+failsafe}
+
exec /sbin/init
diff --git a/target/default/target_skeleton/sbin/mount_root b/target/default/target_skeleton/sbin/mount_root
new file mode 100755
index 000000000..db73eaed5
--- /dev/null
+++ b/target/default/target_skeleton/sbin/mount_root
@@ -0,0 +1,24 @@
+#!/bin/sh
+if [ "$1" != "failsafe" ]; then
+ mount | grep jffs2 >&-
+ if [ $? = 0 ] ; then
+ mtd unlock rootfs
+ [ $(cat /proc/mtd | wc -l) = 6 ] && {
+ echo 5 > /proc/sys/diag
+ mtd unlock OpenWrt
+ mtd erase OpenWrt
+ jffs2root --move
+ }
+ mount -o remount,rw /dev/root /
+ else
+ mtd unlock mtd4
+ mount -t jffs2 /dev/mtdblock/4 /jffs
+ pivot_root /jffs /jffs/rom
+ mount none /proc -t proc
+ mount none /dev -t devfs
+ umount rom/proc rom/dev
+ fi
+fi
+mount none /tmp -t ramfs
+mkdir -p /dev/pts
+mount none /dev/pts -t devpts